<?php
/*
 * Security Ninja
 * (c) 2011 - 2018 Web factory Ltd
 *
 */

class wf_sn_af_fix_readme_check extends wf_sn_af {
  static function get_label($label) {
    $labels = array('title' => 'Remove readme.html file',
					'fixable' => true,
					'info' => '<i>readme.html</i> file will be renamed so it is not available on the default location.',
					'msg_ok' => 'Fix applied successfully.',
					'msg_bad' => 'Rename failed.');  
    if(!array_key_exists($label,$labels)){
      return '';	
    } else {	
      return $labels[$label];
    }
  }
  					
  static function fix() {
	if(!file_exists(ABSPATH . 'readme.html')){
	  return 'readme.html not found at default locations.';	
	}
	
    wf_sn_af::backup_file(ABSPATH . 'readme.html', time(), 'readme_check');
    if(unlink(ABSPATH . 'readme.html')){
      wf_sn_af::mark_as_fixed('readme_check');
      return self::get_label('msg_ok');	
    } else {
      return self::get_label('msg_bad');
    }
  }   
} // wf_sn_af_fix_readme_check
