<?php
/*
 * Security Ninja
 * (c) 2011 - 2018 Web factory Ltd
 *
 */

class wf_sn_af_fix_upgrade_file_check extends wf_sn_af {
  static function get_label($label) {
    $labels = array('title' => 'Rename upgrade.php',
					'fixable' => true,
					'info' => 'Rename upgrade.php so it is not accessible on the default location.',
					'msg_ok' => 'Fix applied successfully.',
					'msg_bad' => 'Rename failed.');  
    if(!array_key_exists($label,$labels)){
      return '';	
    } else {	
      return $labels[$label];
    }
  }
  					
  static function fix() {
    $new_name='upgrade_'.time().'.php';  
    if(rename(ABSPATH . 'wp-admin/upgrade.php', ABSPATH . 'wp-admin/' . $new_name)){
      wf_sn_af::mark_as_fixed('upgrade_file_check');	
      return 'Renamed Sucessfuly to ' . $new_name;
    } else {
      return self::get_label('msg_bad');
    }
  }
} // wf_sn_af_fix_upgrade_file_check
